# 区块链钱包技术指南

随着区块链技术的发展，伴随而来的巨大经济效益也是日益突显，区块链技术离我们的生活也越来越近，近期兴起的币市风暴，想必了解区块链的人都略知一二。我们都知道，目前的区块链技术主要有两大阵营，币圈和链圈，币圈主要以公链技术、钱包技术延伸出一系列的公司和产品，而链圈主要的联盟链技术。我们此书讲解的内容主要还是属于币圈的技术，书中会涉及到公链的一些技术，但书的主要内容还区块链钱包技术。


本书所要讲授的内容就是目前最流行的技术之一的区块链钱包技术，我们将会从基础知识开始讲授，一直深入到钱包技术的核心，最后的章节将做两个笔者主导开发的区块链钱包技术实战的讲授。虽说我写本书的时候会从最基本的内容讲，但是编程语言层面的东西本书不会过多的讲解。希望阅读本书的读者可以自己把本书涉及到的编程语言、网络协议和加密算法提前了解一下。本书针对区块链钱包的开发者和对区块链钱包技术感兴趣的人。


阅读本书之前，你可能需要对下面的技术和编程语言有所了解：

* 公链技术（尤其目前公链支持的账户体系及时，当然本书对这部分的内容会做详细的介绍）
* 加密算法
* Golang（目前区块链技术中使用最广泛的编程语言之一）
* Java（承载钱包的业务逻辑）
* Nodejs（钱包本地账户，交易签名）
* electron（前端桌面框架，在项目实战中会用到）
* Vue（前端框架，项目实战中将会用到）
* Nginx
* 数据库技术
* 网络通信技术
* 点对点网络通信
* IOS和Android

涉及到的技术远远不只上面这些，上面只是钱包技术中使用到的比较重要的技术。


笔者之所以写这本书，是为了广大的区块链爱好者可以更好的学习块链钱包技术，目前网络上讲解区块链钱包的文章，可谓少之又少，而且质量也是参差不齐。影响广大区块链爱好者的理解与学习。现在掌握区块链钱包技术的人才并不多，市场上也没有一本把区块链钱包技术介绍透彻的书，当然，笔者也不一定能把这个技术介绍得很透彻，笔者的水平有限，如果本书中有什么错误的地方，欢迎大家交流指正。


[点击开始阅读本书](https://github.com/guoshijiang/blockchain-wallet/blob/master/chapter/readme.md)

[点击开始阅读作者的Docker一书](https://github.com/guoshijiang/docker-virtual-technology)

[跳转到笔者的博客](https://blog.csdn.net/jiang_xinxing)

### 有兴趣的朋友可以加笔者的微信，我们一起交流区块链技术，区块链钱包技术

.： 
    ![.： 
](https://github.com/guoshijiang/blockchain-wallet/blob/master/img/weixin.png)


### 关于本书

目前本书在写作阶段，书籍的版本暂设为V1.0.0版，本书将一直跟随区块链钱包技术的发展，随时更新,本书的内容将会在笔者的博客上同步更新，可能内容上不太一致，希望读者多多包涵。


### 赞助本教程

- ETH: 0xe3b4ECd2EC88026F84cF17fef8bABfD9184C94F0
- ERC20: 0xe3b4ECd2EC88026F84cF17fef8bABfD9184C94F0
- Layer2: 0xe3b4ECd2EC88026F84cF17fef8bABfD9184C94F0


### SavourLabs 社区招募区块链开发者

目前我们正在在招募 Python, Go, Rust 和 Node 开发工程师，前端开发工程师(Vue 和 React 方向)，产品经理， 视觉设计师和密码学研究员，欢迎有兴趣的朋友联系我们，联系方式如下：

- 邮箱：guoshijiang2012@163.com
- 微信：LGZAXE
- discord: https://discord.gg/WW86tqEw
- telegram: @shijiangguo
- Twitter: @seek_web3

